Allow use of comments in file /etc/debootstrap/packages; install postfix
[grml-debootstrap.git] / grml-debootstrap
old mode 100644 (file)
new mode 100755 (executable)
index 7a14e5f..0182ee9
 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
-# Latest change: Mon Apr 16 13:21:01 CEST 2007 [mika]
 ################################################################################
 # http://www.debian.org/releases/stable/i386/index.html.en
 
 set -e # exit on any error
 
-VERSION='0.8'
+# variables {{{
+PN="$(basename $0)"
+VERSION='0.18'
+MNTPOINT="/mnt/debootstrap.$$"
+
+# inside the chroot system locales might not be available, so use minimum:
+export LANG=C
+export LC_ALL=C
+
+# make sure interactive mode is only executed when
+# using an empty configuration file or option --interactive
+INTERACTIVE=''
+# }}}
 
 # source core functions {{{
 . /etc/grml/lsb-functions
 . /etc/grml/script-functions
 # }}}
 
+# help text {{{
+usage() {
+  echo "$PN - wrapper around debootstrap for installing Debian
+
+Usage: $PN [options]
+
+  -h|--help                   Print this usage information and exit.
+  -v|--version                Show summary of options and exit.
+
+  -c|--config <configfile>    Use specified configuration file,
+                              defaults to /etc/debootstrap/config
+  -i|--iso <mnt>              Mountpoint where a Debian ISO is mounted to,
+                              for use instead of fetching packages from a mirror
+  -m|--mirror <URL>           Mirror which should be used for apt-get/aptitude.
+  -p|--mntpoint <mnt>         Mountpoint used for mounting the target system.
+  -r|--release <release>      Release of new Debian system (default: stable)
+  -t|--target <target>        Target partition (/dev/...) or directory.
+
+  --boot_append <appendline>  Add specified appendline to kernel whilst booting
+  --groot <device>            Root device for usage in grub, corresponds with
+                              \$TARGET in grub syntax, like hd0,0 for /dev/sda1
+  --grub <device>             Target for grub installation. Use grub syntax
+                              for specifying, like hd0 for /dev/sda
+  --interactive               Use interactive mode (frontend)
+  --password <pwd>            Use specified password as password for user root.
+
+Send bugreports to the grml-team: bugs@grml.org || http://grml.org/bugs/
+"
+}
+
+if [ "$1" = '-h' ] || [ "$1" = '-help' ] ; then
+   usage
+   echo 'Please notice that this script requires root permissions!'
+   exit 0
+fi
+# }}}
+
 # make sure we have what we need {{{
-check4progs debootstrap || exit 1
+check4progs debootstrap dialog || exit 1
 check4root || exit 1
 # }}}
 
+# source configuration file {{{
+if [ -r /etc/debootstrap/config ] ; then
+   if [ -n "$CONFIGFILE" ] ; then
+      if ! . "$CONFIGFILE" ; then
+         eerror "Error reading config file $CONFIGFILE" ; eend 1 ; exit 1
+      fi
+   else
+      . /etc/debootstrap/config
+   fi
+fi
+# }}}
+
 # cmdline handling {{{
-case $* in
-   -h*|--h*)
-     einfo "$0 - wrapper around debootstrap for installing plain Debian via grml"
-     einfo "Adjust /etc/debootstrap/config and invoke $0 afterwards."
-     eend 0
-     exit 0
-   ;;
-   -v|--v*)
-     einfo "$0 version $VERSION"
-     einfo "Send bug reports to Michael Prokop <mika@grml.org>."
-     eend 0
-     exit 0
-   ;;
-esac
+
+while [ "$#" -gt "0" ] ; do
+    case $1 in
+        -c|--config)
+            shift
+            CONFIGFILE=$1
+            ;;
+        --grub)
+            shift
+            GRUB=$1
+            ;;
+        --groot)
+            shift
+            GROOT=$1
+            ;;
+        -h|--help)
+            usage ; eend 0
+            eend 0
+            exit 0
+            ;;
+        --interactive)
+            INTERACTIVE=1
+            ;;
+        -i|--iso)
+            shift
+            [ -n "$MIRROR" ] && unset MIRROR
+            ISO=$1
+            ;;
+        -m|--mirror)
+            shift
+            MIRROR=$1
+            CHROOTMIRROR=$1
+            ;;
+        -p|--mntpoint)
+            shift
+            MNTPOINT=$1
+            ;;
+        --password)
+            shift
+            ROOTPASSWORD=$1
+            ;;
+        -r|--release)
+            shift
+            RELEASE=$1
+            ;;
+        -t|--target)
+            shift
+            TARGET=$1
+            ;;
+        -v|--version)
+            einfo "$PN - version $VERSION"
+            einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
+            eend 0
+            exit 0
+            ;;
+        *)
+            eerror "Syntax error."
+            usage ; eend 1
+            exit 1
+            ;;
+    esac
+    shift
+done
 # }}}
 
-# without config file it won't work {{{
-if [ -r /etc/debootstrap/config ] ; then
-   . /etc/debootstrap/config
+# welcome screen {{{
+welcome_dialog()
+{
+   dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
+Do you want to continue installing Debian using this frontend?" 0 0
+}
+# }}}
+
+# ask for target {{{
+prompt_for_target()
+{
+  AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
+               sed 's/*//' | \
+               grep -v 'Extended$' | \
+               gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
+
+  [ -n "$AVAILABLE_PARTITIONS" ] || echo "FIXME: no partitions available?"
+  PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
+                       echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet])"
+                   done)
+
+  TARGET=$(dialog --title "$PN" --single-quoted --stdout \
+         --menu "Please select the target partition:" 0 0 0 \
+         $PARTITION_LIST)
+}
+# }}}
+
+# ask for bootmanager {{{
+prompt_for_bootmanager()
+{
+  ADDITIONAL_PARAMS=""
+  for device in sda hda; do
+    if [ /dev/$device != ${TARGET%[0-9]} ]; then
+      grep -q $device /proc/partitions && \
+      ADDITIONAL_PARAMS=:$device:"install bootmanager grub into MBR of /dev/${device}"
+    fi
+  done
+  ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
+
+  OIFS="$IFS"; IFS=:
+
+  if echo $TARGET | grep -q "*md*" ; then
+     MBRPART=$TARGET
+  else
+     MBRPART="${TARGET%[0-9]}"
+  fi
+
+  GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
+          --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
+            mbr       "install bootmanager into MBR of $MBRPART" \
+            partition "install bootmanager into partition $TARGET" \
+            nowhere   "do not install bootmanager at all" \
+          ${ADDITIONAL_PARAMS})
+  [ $? -eq 0 ] || bailout 3
+  IFS="$OIFS"
+
+  case "$GETMBR" in
+    mbr)
+      # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
+      if echo $TARGET | grep -q "*md*" ; then
+         BOOT_PARTITION="${TARGET}"
+      else
+         BOOT_PARTITION="${TARGET%[0-9]}"
+      fi
+      ;;
+    partition)
+      BOOT_PARTITION="$TARGET"
+      ;;
+    hda)
+      BOOT_PARTITION="/dev/hda"
+      ;;
+    sda)
+      BOOT_PARTITION="/dev/sda"
+      ;;
+    nowhere)
+      BOOT_PARTITION=''
+      ;;
+  esac
+}
+# }}}
+
+# ask for Debian release {{{
+prompt_for_release()
+{
+  RELEASE="$(dialog --stdout --title "${PN}" --default-item etch --menu \
+            "Please enter the Debian release you would like to use for installation:" \
+            0 50 3 \
+            etch   Debian/stable \
+            lenny  Debian/testing \
+            sid    Debian/unstable)"
+}
+# }}}
+
+# ask for Debian mirror {{{
+prompt_for_mirror()
+{
+  MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
+            "Please enter Debian mirror you would like to use for installing packages." \
+            0 0 http://ftp.de.debian.org/debian)"
+}
+# }}}
+
+# get grub's syntax for /dev/ice {{{
+# usage example: 'grubdevice /dev/sda2' returns 'hd0,1'
+grubdevice() {
+  if [ -z "$1" ] ; then
+     echo "Usage: grubdevice <device>">&2
+     return 1
+  fi
+
+  device="$1"
+  device_map=/boot/grub/device.map
+
+  # create device.map
+  if ! [ -f "$device_map" ] ; then
+     echo 'quit' | grub --device-map="$device_map" 1>/dev/null 2>&1
+  fi
+
+  # based on code from d-i's trunk/packages/arch/i386/grub-installer/grub-installer:
+  tmp_disk=`echo "$device" | sed -e 's%\([sh]d[a-z]\)[0-9]*$%\1%' \
+                    -e 's%\(fd[0-9]*\)$%\1%' \
+                    -e 's%/part[0-9]*$%/disc%' \
+                    -e 's%\(c[0-7]d[0-9]*\).*$%\1%'`
+  tmp_part=`echo "$device" | sed -e 's%.*/[sh]d[a-z]\([0-9]*\)$%\1%' \
+                    -e 's%.*/fd[0-9]*$%%' \
+                    -e 's%.*/floppy/[0-9]*$%%' \
+                    -e 's%.*/\(disc\|part\([0-9]*\)\)$%\2%' \
+                    -e 's%.*c[0-7]d[0-9]*p*%%'`
+  tmp_drive=$(grep -v '^#' $device_map | grep "$tmp_disk *$" | sed 's%.*\([hf]d[0-9][a-g0-9,]*\).*%\1%')
+
+  case $1 in
+     /dev/[sh]d[a-z]) # we expect something like 'hd0'
+        echo "$tmp_drive"
+        ;;
+      *) # we expect something like 'hd0,0'
+        echo "$tmp_drive" | sed "s%$%,`expr $tmp_part - 1`%" # FIXME => md0
+        ;;
+  esac
+}
+# }}}
+
+# software raid setup {{{
+config_swraid_setup()
+{
+TMPFILE=$(mktemp)
+RAIDLEVEL=$(dialog --stdout --title "$PN" --default-item raid1 \
+                   --menu "Which RAID level do you want to use?" 0 0 0 \
+                     raid1 "Software RAID level 1" \
+                     raid5 "Software RAID level 5")
+[ $? -eq 0 ] || bailout 20
+
+MD_LIST=$(for i in $(seq 0 9) ; do
+            awk '{print $4}' /proc/partitions | grep -q md$i || \
+            echo "/dev/md$i /dev/md$i"
+          done)
+
+TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
+--menu "Which device do you want to use for ${RAIDLEVEL}?
+
+Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
+$MD_LIST)
+[ $? -eq 0 ] || bailout 20
+
+AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
+             sed 's/*//' | \
+             grep -v 'Extended$' | \
+             gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
+[ -n "$AVAILABLE_PARTITIONS" ] || echo "FIXME: no partitions available?"
+PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
+                     echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet]) off"
+                 done)
+
+dialog --title "$PN" \
+       --single-quoted \
+       --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
+       $PARTITION_LIST 2>$TMPFILE
+RETVAL=$?
+SELECTED_PARTITIONS="$(cat $TMPFILE)"
+
+NUM_PARTITIONS=0
+for i in $(cat $TMPFILE) ; do
+   NUM_PARTITIONS=$((${NUM_PARTITIONS}+1))
+done
+
+ERRORFILE=$(mktemp)
+set +e
+# TODO: better error handling?
+yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
+      --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} 1>/dev/null 2>$ERRORFILE
+RC=$?
+set -e
+
+if [ "$RC" = 0 ] ; then
+   dialog --title "$PN" --msgbox \
+   "Creating $TARGET was successful." 0 0
+   rm -f "$TMPFILE" "$ERRORFILE"
 else
-   eerror "/etc/debootstrap/config could not be read, exiting." ; eend 1
+   dialog --title "$PN" --msgbox \
+   "There was an error setting up $TARGET:
+
+$(cat $ERRORFILE)
+
+Exiting." 0 0
+   rm -f "$TMPFILE" "$ERRORFILE"
    exit 1
 fi
+
+}
+
+prompt_for_swraid()
+{
+if dialog --stdout --title "$PN" \
+          --defaultno --yesno "Do you want to configure Software RAID?
+
+Please notice that currently only RAID levels 1 and 5 are supported by ${PN}. Configuration will take place using mdadm." 0 0 ; then
+  config_swraid_setup
+fi
+}
 # }}}
 
-# set/check variables {{{
+# make sure the user is aware of the used configuration {{{
+checkconfiguration()
+{
+if [ -n "$AUTOINSTALL" ] ; then
+   if checkforrun ; then
+      eerror "Exiting as requested" ; eend 0
+      exit 1
+   fi
+elif [ -n "$INTERACTIVE" ] ; then
 
-# inside the chroot system the locales might not be available, so use minimum:
-export LANG=C
-export LC_ALL=C
+   INFOTEXT="Please recheck configuration before execution:
+   "
+   [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
+   Target:          $TARGET"
+   [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
+   Install grub:    $GRUB"
+   [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
+   Using release:   $RELEASE"
+   [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
+   Using mirror:    $MIRROR"
+
+   INFOTEXT="$INFOTEXT
 
+Is this ok for you? Notice: canceling will exit ${PN}."
+
+   dialog --title "$PN" --no-collapse \
+          --yesno "$INFOTEXT" 0 0
+
+else # if not running automatic installation display configuration and prompt for execution:
+   einfo "$PN - Please recheck configuration before execution:"
+   echo
+   echo "   Target:          $TARGET"
+      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
+      [ -n "$GRUB" ]    && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
+      [ -n "$RELEASE" ] && echo "   Using release:   $RELEASE"
+      [ -n "$MIRROR" ]  && echo "   Using mirror:    $MIRROR"
+      [ -n "$ISO" ]     && echo "   Using iso:       $ISO"
+      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Important! Continuing will delete all data from ${TARGET}!" ;; esac
+      echo
+   einfon "Is this ok for you? [y/N] "
+   read a
+   if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
+      eerror "Exiting as requested." ; eend 1
+      exit 1
+   fi
+fi
+}
+# }}}
+
+# interactive mode {{{
+interactive_mode()
+{
+  welcome_dialog
+
+  prompt_for_swraid
+
+  # do not prompt for partition dialog if swraid has been configured already
+  [ -n "$TARGET" ] || prompt_for_target
+
+  prompt_for_bootmanager
+
+  prompt_for_release
+
+  # FIXME: there seems to be a problem with grubdevice if it's /dev/md*
+  if echo "$TARGET" | grep -q '/dev/md' ; then
+     echo "debug: SELECTED_PARTITIONS = $SELECTED_PARTITIONS">&2
+  else
+     [ -n "$BOOT_PARTITION" ] && GRUB="$(grubdevice $BOOT_PARTITION)"
+     [ -n "$TARGET" ]         && GROOT="$(grubdevice $TARGET)"
+  fi
+
+  prompt_for_mirror
+
+  checkconfiguration
+}
+
+# run interactive mode if we didn't get the according configuration yet
+if [ -z "$TARGET" -o -n "$INTERACTIVE" ] ; then
+   # only target might be unset, so make sure the INTERACTIVE flag is set as well
+   INTERACTIVE=1
+   interactive_mode
+fi
+# }}}
+
+# finally make sure at least $TARGET is set [the partition for the new system] {{{
+if [ -n "$TARGET" ] ; then
+   SHORT_TARGET="${TARGET##*/}"
+else
+   eerror "Please adjust /etc/debootstrap/config or..."
+   eerror "... use the interactive version for configuration before running ${0}" ; eend 1
+   exit 1
+fi
+# }}}
+
+# stages setup {{{
 if [ -z "$STAGES" ] ; then
-   STAGES='/etc/debootstrap/stages'
+   STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
    [ -d "$STAGES" ] || mkdir -p "$STAGES"
 fi
 
-if [ -r $STAGES/grml-debootstrap ] ; then
+if [ -r "$STAGES"/grml-debootstrap ] ; then
    if grep -q done $STAGES/grml-debootstrap ; then
       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
    fi
 fi
+# }}}
 
+# partition handling {{{
 PARTITION=''
 DIRECTORY=''
 
@@ -84,7 +495,9 @@ case $TARGET in
     GROOT=''
     ;;
 esac
+# }}}
 
+# architecture setup {{{
 if [ -n "$ARCH" ] ; then
    ARCHCMD="--arch $ARCH"
    ARCHINFO=" (${ARCH})"
@@ -93,17 +506,35 @@ else
    ARCHCMD="--arch $ARCH"
    ARCHINFO=" (${ARCH})"
 fi
+# }}}
 
-# provide variables to chroot system
-echo "
-ARCH=$ARCH
-" > /etc/debootstrap/variables
-
-# make sure at least $TARGET is set [the partition for the new system]
-if [ -z "$TARGET" ] ; then
-   eerror "Please adjust /etc/debootstrap/config before running ${0}" ; eend 1
-   exit 1
+# make sure we have the right syntax when using an iso image {{{
+if [ -n "$ISO" ] ; then
+   case $ISO in
+      file*) # do nothing
+      ;;
+      *)
+      ISO=file:$1
+      ;;
+   esac
 fi
+ISODIR=${ISO##file:}
+ISODIR=${ISODIR%%/}
+# }}}
+
+# provide variables to chroot system {{{
+CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
+touch $CHROOT_VARIABLES
+chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
+[ -n "$ARCH" ]   && echo "ARCH=$ARCH"     >  $CHROOT_VARIABLES
+[ -n "$GRUB" ]   && echo "GRUB=$GRUB"     >> $CHROOT_VARIABLES
+[ -n "$GROOT" ]  && echo "GROOT=$GROOT"   >> $CHROOT_VARIABLES
+[ -n "$TARGET" ] && echo "TARGET=$TARGET" >> $CHROOT_VARIABLES
+[ -n "$ISO" ]    && echo "ISO=$ISO"       >> $CHROOT_VARIABLES
+[ -n "$ISODIR" ] && echo "ISODIR=$ISO"    >> $CHROOT_VARIABLES
+[ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> $CHROOT_VARIABLES
+[ -n "$MIRROR" ] && echo "CHROOTMIRROR=$MIRROR" >> $CHROOT_VARIABLES
+[ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
 # }}}
 
 # helper functions {{{
@@ -115,45 +546,60 @@ bailout(){
         # make sure nothing is left inside chroot so we can unmount it
         [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
         [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /sys
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc
-        einfo "Unmounting $MNTPOINT" ; umount "$MNTPOINT" ; eend $?
+        # ugly, but make sure we really don't leav anything
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /sys  1>/dev/null 2>&1
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a    1>/dev/null 2>&1
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
+        [ -d "$MNTPOINT/$ISODIR" ]    && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
+        einfo "Unmounting $MNTPOINT"   ; umount "$MNTPOINT" ; eend $?
+
+        if [ -n "$STAGES" ] ; then
+           echo -n "Removing stages directory ${STAGES}: "
+           rm -rf "$STAGES" && echo done
+        fi
+
+        # remove directory only if we used the default with process id inside the name
+        if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
+           einfo "Removing directory ${MNTPOINT}" ; rmdir $MNTPOINT ; eend $?
+        fi
      fi
   fi
+
   [ -n "$1" ] && EXIT="$1" || EXIT="1"
   [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
+
   exit "$EXIT"
 }
-trap bailout 1 2 3 15
+trap bailout HUP INT QUIT TERM
 
 # we want to execute all the functions only once, simple check for it:
 stage() {
   if [ -n "$2" ] ; then
-     echo "$2" > "$STAGES/$1"
+     echo "$2" > "${STAGES}/${1}"
      return 0
-  elif grep -q done "$STAGES/$1" 2>/dev/null ; then
+  elif grep -q done "${STAGES}/${1}" 2>/dev/null ; then
      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
+     eindent
+       ewarn "To reexecute it clean up the according directory inside $STAGES" ; eend 0
+     eoutdent
      return 1
   fi
 }
 # }}}
 
 # user should recheck his configuration {{{
-einfo "$0 - Please recheck configuration before execution:"
-echo "
-   Target:           $TARGET"
-   case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount-point:      $MNTPOINT" ;; esac
-   [ -n "$GRUB" ] && echo "   Install grub to:  $GROOT / $GRUB"
-   case "$MNTPOINT" in "$TARGET") ;; *) echo "  Important! Continuing will delete all data from ${TARGET}!" ;; esac
-   echo
-einfon "Is this ok for you? [y/N] "
+# support full automatic installation:
+checkforrun() {
+   dialog --timeout 10 --title "$PN" \
+          --yesno "Do you want to stop at this stage?
 
-read a
-if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
-   eerror "Exiting as requested." ; eend 1
-   exit 1
-fi
-# }}}
+Notice: you are running ${PN} in non-interactive mode.
+${PN} will install Debian ${RELEASE} on ${TARGET}.
+Last chance to quit. Timeout of 10 seconds running....
+
+Do you want to stop now?" 0 0 2>/dev/null
+}
 
 # create filesystem {{{
 mkfs() {
@@ -183,24 +629,30 @@ mount_target() {
      if grep -q $TARGET /proc/mounts ; then
         eerror "$TARGET already mounted, exiting."
      else
-       [ -n "$MNTPOINT" ] || MNTPOINT='/mnt/test'
        [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
        einfo "Mounting $TARGET to $MNTPOINT"
        mount -o rw,suid,dev $TARGET $MNTPOINT
        eend $?
      fi
   fi
+  if [ -n "$ISODIR" ] ; then
+     einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
+     mkdir -p "$MNTPOINT/$ISODIR"
+     mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
+     eend $?
+  fi
 }
 # }}}
 
 # install main chroot {{{
 debootstrap_system() {
   if ! grep -q $MNTPOINT /proc/mounts ; then
-          mount_target
+     mount_target
   fi
   if grep -q $MNTPOINT /proc/mounts ; then
-     einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using mirror $MIRROR"
-     $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR
+     einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
+     [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR || \
+     $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $ISO
      eend $?
   else
      eerror "Error: $MNTPOINT not mounted, can not continue."
@@ -218,21 +670,47 @@ preparechroot() {
 
   # make sure we have our files for later use via chroot-script
   cp /etc/debootstrap/config    $MNTPOINT/etc/debootstrap/
+  # make sure we adjust the configuration variables accordingly:
+  sed -i "s/RELEASE=.*/RELEASE=\"$RELEASE\"/" $MNTPOINT/etc/debootstrap/config
+  sed -i "s/TARGET=.*/TARGET=\"$TARGET\"/"    $MNTPOINT/etc/debootstrap/config
+  sed -i "s/GRUB=.*/GRUB=\"$GRUB\"/"          $MNTPOINT/etc/debootstrap/config
+  sed -i "s/GROOT=.*/GROOT=\"$GROOT\"/"       $MNTPOINT/etc/debootstrap/config
+
   cp /etc/debootstrap/packages  $MNTPOINT/etc/debootstrap/packages
-  cp /etc/debootstrap/variables $MNTPOINT/etc/debootstrap/variables
+
+  # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
+  cp $CHROOT_VARIABLES          $MNTPOINT/etc/debootstrap/variables
+
+  cp -a /etc/debootstrap/extrapackages/ $MNTPOINT/etc/debootstrap/
 
   # make sure we can access network [relevant for cdebootstrap]
   [ -f "$MNTPOINT/etc/resolv.conf" ] || cp /etc/resolv.conf $MNTPOINT/etc/resolv.conf
 
+  # provide system's /etc/hosts to the target:
+  if ! [ -f "$MNTPOINT/etc/hosts" ] ; then
+     cp /etc/hosts $MNTPOINT/etc/hosts
+     sed -i "s/127.0.0.1 .*/127.0.0.1       localhost  $HOSTNAME/" /etc/hosts
+  fi
+
   # setup default locales
   [ -n "$LOCALES" ] && cp /etc/debootstrap/locale.gen  $MNTPOINT/etc/locale.gen
 
+  # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
+  ( cd $MNTPOINT/dev && tar zxf /etc/debootstrap/devices.tar.gz )
+
   # copy any existing existing files to chroot
   [ -d /etc/debootstrap/boot  ] && cp -a /etc/debootstrap/boot/*  $MNTPOINT/boot/
   [ -d /etc/debootstrap/etc   ] && cp -a /etc/debootstrap/etc/*   $MNTPOINT/etc/
   [ -d /etc/debootstrap/share ] && cp -a /etc/debootstrap/share/* $MNTPOINT/share/
   [ -d /etc/debootstrap/usr   ] && cp -a /etc/debootstrap/usr/*   $MNTPOINT/usr/
   [ -d /etc/debootstrap/var   ] && cp -a /etc/debootstrap/var/*   $MNTPOINT/var/
+
+  # copy local network setup to chroot
+  if [ -r /etc/network/interfaces -a ! -r "${MNTPOINT}"/etc/network/interfaces ] ; then
+     [ -d $MNTPOINT/etc/network ] || mkdir $MNTPOINT/etc/network
+     cp /etc/network/interfaces $MNTPOINT/etc/network/interfaces
+  fi
+
   eend 0
 }
 # }}}
@@ -257,9 +735,18 @@ chrootscript() {
 grub_install() {
   if [ -z "$GRUB" -o -z "$GROOT" ] ; then
      echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
+  elif [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
+     for device in $SELECTED_PARTITIONS ; do
+        GRUB=$(grubdevice $device)
+        einfo "Installing grub on ${GRUB}:"
+        [ -x /usr/sbin/grub-install ] && GRUBINSTALL=/usr/sbin/grub-install || GRUBINSTALL=/sbin/grub-install
+        $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
+        eend $?
+     done
   else
      einfo "Installing grub on ${GRUB}:"
-     grub-install --root-directory="$MNTPOINT" "(${GRUB})"
+     [ -x /usr/sbin/grub-install ] && GRUBINSTALL=/usr/sbin/grub-install || GRUBINSTALL=/sbin/grub-install
+     $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
      eend $?
   fi
 }
@@ -267,10 +754,19 @@ grub_install() {
 
 # unmount $MNTPOINRT {{{
 umount_chroot() {
-  if [ -n "$PARTITION" ] ; then
-     einfo "Unmount $MNTPOINT"
-     umount $MNTPOINT
-     eend $?
+  if [ -n "$ISODIR" ] ; then
+     if grep -q "$ISODIR" /proc/mounts ; then
+        einfo "Unmount $MNTPOINT/$ISODIR"
+        umount "$MNTPOINT/$ISODIR"
+        eend $?
+     fi
+  fi
+  if grep -q "$MNTPOINT" /proc/mounts ; then
+     if [ -n "$PARTITION" ] ; then
+        einfo "Unmount $MNTPOINT"
+        umount $MNTPOINT
+        eend $?
+     fi
   fi
 }
 # }}}
@@ -289,17 +785,28 @@ fscktool() {
 # now execute all the functions {{{
 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
          chrootscript grub_install umount_chroot fscktool ; do
-    if stage $i ; then
-       $i && stage $i done || bailout 2 "i"
+    if stage "${i}" ; then
+       $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "i"
     fi
 done
 # }}}
 
-# stages {{{
-  echo done > $STAGES/grml-debootstrap
+# finalize {{{
+# Remove temporary mountpoint again
+if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
+   einfo "Removing directory ${MNTPOINT}" ; rmdir "$MNTPOINT" ; eend $?
+   einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
+fi
 # }}}
 
-  einfo "Finished execution of $0 - enjoy your Debian system." ; eend 0
+# end dialog of autoinstallation {{{
+if [ -n "$AUTOINSTALL" ] ; then
+   dialog --title "$PN" --msgbox \
+          "Finished execution of ${PN}. Enjoy your Debian system." 0 0
+else
+   einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
+fi
+# }}}
 
 ## END OF FILE #################################################################
-# vim: ai tw=100 expandtab foldmethod=marker
+# vim: ai tw=100 expandtab foldmethod=marker shiftwidth=3